Index: protocols/jabber/s5bytestream.c
===================================================================
--- protocols/jabber/s5bytestream.c	(revision 34afea7dd6b066a9e7153d16a8e386c7c90ffe87)
+++ protocols/jabber/s5bytestream.c	(revision 5ebff60479fc7a9f7f50ac03b124c91d4e6ebe11)
@@ -34,9 +34,8 @@
 	GSList *streamhosts;
 
-	enum 
-	{ 
-		BS_PHASE_CONNECT, 
-		BS_PHASE_CONNECTED, 
-		BS_PHASE_REQUEST, 
+	enum {
+		BS_PHASE_CONNECT,
+		BS_PHASE_CONNECTED,
+		BS_PHASE_REQUEST,
 		BS_PHASE_REPLY
 	} phase;
@@ -46,14 +45,12 @@
 
 	gint connect_timeout;
-	
+
 	char peek_buf[64];
 	int peek_buf_len;
 };
 
-struct socks5_message
-{
+struct socks5_message {
 	unsigned char ver;
-	union
-	{
+	union {
 		unsigned char cmd;
 		unsigned char rep;
@@ -64,5 +61,5 @@
 	unsigned char address[40];
 	in_port_t port;
-} __attribute__ ((packed)); 
+} __attribute__ ((packed));
 
 char *socks5_reply_code[] = {
@@ -76,5 +73,6 @@
 	"Command not supported",
 	"Address type not supported",
-	"unassigned"};
+	"unassigned"
+};
 
 /* connect() timeout in seconds. */
@@ -85,67 +83,64 @@
 /* very useful */
 #define ASSERTSOCKOP(op, msg) \
-	if( (op) == -1 ) \
-		return jabber_bs_abort( bt , msg ": %s", strerror( errno ) );
-
-gboolean jabber_bs_abort( struct bs_transfer *bt, char *format, ... );
-void jabber_bs_canceled( file_transfer_t *ft , char *reason );
-void jabber_bs_free_transfer( file_transfer_t *ft );
-gboolean jabber_bs_connect_timeout( gpointer data, gint fd, b_input_condition cond );
-gboolean jabber_bs_poll( struct bs_transfer *bt, int fd, short *revents );
-gboolean jabber_bs_peek( struct bs_transfer *bt, void *buffer, int buflen );
-
-void jabber_bs_recv_answer_request( struct bs_transfer *bt );
-gboolean jabber_bs_recv_read( gpointer data, gint fd, b_input_condition cond );
-gboolean jabber_bs_recv_write_request( file_transfer_t *ft );
-gboolean jabber_bs_recv_handshake( gpointer data, gint fd, b_input_condition cond );
-gboolean jabber_bs_recv_handshake_abort( struct bs_transfer *bt, char *error );
-int jabber_bs_recv_request( struct im_connection *ic, struct xt_node *node, struct xt_node *qnode );
-
-gboolean jabber_bs_send_handshake_abort( struct bs_transfer *bt, char *error );
-gboolean jabber_bs_send_request( struct jabber_transfer *tf, GSList *streamhosts );
-gboolean jabber_bs_send_handshake( gpointer data, gint fd, b_input_condition cond );
-static xt_status jabber_bs_send_handle_activate( struct im_connection *ic, struct xt_node *node, struct xt_node *orig );
-void jabber_bs_send_activate( struct bs_transfer *bt );
+	if ((op) == -1) { \
+		return jabber_bs_abort(bt, msg ": %s", strerror(errno)); }
+
+gboolean jabber_bs_abort(struct bs_transfer *bt, char *format, ...);
+void jabber_bs_canceled(file_transfer_t *ft, char *reason);
+void jabber_bs_free_transfer(file_transfer_t *ft);
+gboolean jabber_bs_connect_timeout(gpointer data, gint fd, b_input_condition cond);
+gboolean jabber_bs_poll(struct bs_transfer *bt, int fd, short *revents);
+gboolean jabber_bs_peek(struct bs_transfer *bt, void *buffer, int buflen);
+
+void jabber_bs_recv_answer_request(struct bs_transfer *bt);
+gboolean jabber_bs_recv_read(gpointer data, gint fd, b_input_condition cond);
+gboolean jabber_bs_recv_write_request(file_transfer_t *ft);
+gboolean jabber_bs_recv_handshake(gpointer data, gint fd, b_input_condition cond);
+gboolean jabber_bs_recv_handshake_abort(struct bs_transfer *bt, char *error);
+int jabber_bs_recv_request(struct im_connection *ic, struct xt_node *node, struct xt_node *qnode);
+
+gboolean jabber_bs_send_handshake_abort(struct bs_transfer *bt, char *error);
+gboolean jabber_bs_send_request(struct jabber_transfer *tf, GSList *streamhosts);
+gboolean jabber_bs_send_handshake(gpointer data, gint fd, b_input_condition cond);
+static xt_status jabber_bs_send_handle_activate(struct im_connection *ic, struct xt_node *node, struct xt_node *orig);
+void jabber_bs_send_activate(struct bs_transfer *bt);
 
 /*
  * Frees a bs_transfer struct and calls the SI free function
  */
-void jabber_bs_free_transfer( file_transfer_t *ft) {
+void jabber_bs_free_transfer(file_transfer_t *ft)
+{
 	struct jabber_transfer *tf = ft->data;
 	struct bs_transfer *bt = tf->streamhandle;
 	jabber_streamhost_t *sh;
 
-	if ( bt->connect_timeout )
-	{
-		b_event_remove( bt->connect_timeout );
+	if (bt->connect_timeout) {
+		b_event_remove(bt->connect_timeout);
 		bt->connect_timeout = 0;
 	}
 
-	if ( tf->watch_in )
-	{
-		b_event_remove( tf->watch_in );
+	if (tf->watch_in) {
+		b_event_remove(tf->watch_in);
 		tf->watch_in = 0;
 	}
-	
-	if( tf->watch_out )
-	{
-		b_event_remove( tf->watch_out );
+
+	if (tf->watch_out) {
+		b_event_remove(tf->watch_out);
 		tf->watch_out = 0;
 	}
-	
-	g_free( bt->pseudoadr );
-
-	while( bt->streamhosts )
-	{
+
+	g_free(bt->pseudoadr);
+
+	while (bt->streamhosts) {
 		sh = bt->streamhosts->data;
-		bt->streamhosts = g_slist_remove( bt->streamhosts, sh );
-		g_free( sh->jid );
-		g_free( sh->host );
-		g_free( sh );
-	}
-	
-	g_free( bt );
-
-	jabber_si_free_transfer( ft );
+		bt->streamhosts = g_slist_remove(bt->streamhosts, sh);
+		g_free(sh->jid);
+		g_free(sh->host);
+		g_free(sh);
+	}
+
+	g_free(bt);
+
+	jabber_si_free_transfer(ft);
 }
 
@@ -154,36 +149,37 @@
  * writes it to buffer if that's the case.
  */
-gboolean jabber_bs_peek( struct bs_transfer *bt, void *buffer, int buflen )
+gboolean jabber_bs_peek(struct bs_transfer *bt, void *buffer, int buflen)
 {
 	int ret;
 	int fd = bt->tf->fd;
 
-	if( buflen > sizeof( bt->peek_buf ) )
-		return jabber_bs_abort( bt, "BUG: %d > sizeof(peek_buf)", buflen );
-
-	ASSERTSOCKOP( ret = recv( fd, bt->peek_buf + bt->peek_buf_len,
-		buflen - bt->peek_buf_len, 0 ), "recv() on SOCKS5 connection" );
-
-	if( ret == 0 )
-		return jabber_bs_abort( bt, "Remote end closed connection" );
-	
+	if (buflen > sizeof(bt->peek_buf)) {
+		return jabber_bs_abort(bt, "BUG: %d > sizeof(peek_buf)", buflen);
+	}
+
+	ASSERTSOCKOP(ret = recv(fd, bt->peek_buf + bt->peek_buf_len,
+	                        buflen - bt->peek_buf_len, 0), "recv() on SOCKS5 connection");
+
+	if (ret == 0) {
+		return jabber_bs_abort(bt, "Remote end closed connection");
+	}
+
 	bt->peek_buf_len += ret;
-	memcpy( buffer, bt->peek_buf, bt->peek_buf_len );
-	
-	if( bt->peek_buf_len == buflen )
-	{
+	memcpy(buffer, bt->peek_buf, bt->peek_buf_len);
+
+	if (bt->peek_buf_len == buflen) {
 		/* If we have everything the caller wanted, reset the peek buffer. */
 		bt->peek_buf_len = 0;
 		return buflen;
-	}
-	else
+	} else {
 		return bt->peek_buf_len;
-}
-
-
-/* 
+	}
+}
+
+
+/*
  * This function is scheduled in bs_handshake via b_timeout_add after a (non-blocking) connect().
  */
-gboolean jabber_bs_connect_timeout( gpointer data, gint fd, b_input_condition cond )
+gboolean jabber_bs_connect_timeout(gpointer data, gint fd, b_input_condition cond)
 {
 	struct bs_transfer *bt = data;
@@ -191,44 +187,47 @@
 	bt->connect_timeout = 0;
 
-	jabber_bs_abort( bt, "no connection after %d seconds", bt->tf->ft->sending ? JABBER_BS_LISTEN_TIMEOUT : JABBER_BS_CONTIMEOUT );
+	jabber_bs_abort(bt, "no connection after %d seconds",
+	                bt->tf->ft->sending ? JABBER_BS_LISTEN_TIMEOUT : JABBER_BS_CONTIMEOUT);
 
 	return FALSE;
 }
 
-/* 
+/*
  * Polls the socket, checks for errors and removes a connect timer
  * if there is one.
  */
-gboolean jabber_bs_poll( struct bs_transfer *bt, int fd, short *revents )
-{
-	struct pollfd pfd = { .fd = fd, .events = POLLHUP|POLLERR };
-	
-	if ( bt->connect_timeout )
-	{
-		b_event_remove( bt->connect_timeout );
+gboolean jabber_bs_poll(struct bs_transfer *bt, int fd, short *revents)
+{
+	struct pollfd pfd = { .fd = fd, .events = POLLHUP | POLLERR };
+
+	if (bt->connect_timeout) {
+		b_event_remove(bt->connect_timeout);
 		bt->connect_timeout = 0;
 	}
 
-	ASSERTSOCKOP( poll( &pfd, 1, 0 ), "poll()" )
-
-	if( pfd.revents & POLLERR )
-	{
+	ASSERTSOCKOP(poll(&pfd, 1, 0), "poll()")
+
+	if (pfd.revents & POLLERR) {
 		int sockerror;
-		socklen_t errlen = sizeof( sockerror );
-
-		if ( getsockopt( fd, SOL_SOCKET, SO_ERROR, &sockerror, &errlen ) )
-			return jabber_bs_abort( bt, "getsockopt() failed, unknown socket error during SOCKS5 handshake (weird!)" );
-
-		if ( bt->phase == BS_PHASE_CONNECTED )
-			return jabber_bs_abort( bt, "connect failed: %s", strerror( sockerror ) );
-
-		return jabber_bs_abort( bt, "Socket error during SOCKS5 handshake(weird!): %s", strerror( sockerror ) );
-	}
-
-	if( pfd.revents & POLLHUP )
-		return jabber_bs_abort( bt, "Remote end closed connection" );
-	
+		socklen_t errlen = sizeof(sockerror);
+
+		if (getsockopt(fd, SOL_SOCKET, SO_ERROR, &sockerror, &errlen)) {
+			return jabber_bs_abort(bt,
+			                       "getsockopt() failed, unknown socket error during SOCKS5 handshake (weird!)");
+		}
+
+		if (bt->phase == BS_PHASE_CONNECTED) {
+			return jabber_bs_abort(bt, "connect failed: %s", strerror(sockerror));
+		}
+
+		return jabber_bs_abort(bt, "Socket error during SOCKS5 handshake(weird!): %s", strerror(sockerror));
+	}
+
+	if (pfd.revents & POLLHUP) {
+		return jabber_bs_abort(bt, "Remote end closed connection");
+	}
+
 	*revents = pfd.revents;
-	
+
 	return TRUE;
 }
@@ -237,25 +236,28 @@
  * Used for receive and send path.
  */
-gboolean jabber_bs_abort( struct bs_transfer *bt, char *format, ... )
+gboolean jabber_bs_abort(struct bs_transfer *bt, char *format, ...)
 {
 	va_list params;
-	va_start( params, format );
+
+	va_start(params, format);
 	char error[128];
 
-	if( vsnprintf( error, 128, format, params ) < 0 )
-		sprintf( error, "internal error parsing error string (BUG)" );
-	va_end( params );
-	if( bt->tf->ft->sending )
-		return jabber_bs_send_handshake_abort( bt, error );
-	else
-		return jabber_bs_recv_handshake_abort( bt, error );
+	if (vsnprintf(error, 128, format, params) < 0) {
+		sprintf(error, "internal error parsing error string (BUG)");
+	}
+	va_end(params);
+	if (bt->tf->ft->sending) {
+		return jabber_bs_send_handshake_abort(bt, error);
+	} else {
+		return jabber_bs_recv_handshake_abort(bt, error);
+	}
 }
 
 /* Bad luck */
-void jabber_bs_canceled( file_transfer_t *ft , char *reason )
+void jabber_bs_canceled(file_transfer_t *ft, char *reason)
 {
 	struct jabber_transfer *tf = ft->data;
 
-	imcb_log( tf->ic, "File transfer aborted: %s", reason );
+	imcb_log(tf->ic, "File transfer aborted: %s", reason);
 }
 
@@ -263,5 +265,5 @@
  * Parses an incoming bytestream request and calls jabber_bs_handshake on success.
  */
-int jabber_bs_recv_request( struct im_connection *ic, struct xt_node *node, struct xt_node *qnode)
+int jabber_bs_recv_request(struct im_connection *ic, struct xt_node *node, struct xt_node *qnode)
 {
 	char *sid, *ini_jid, *tgt_jid, *mode, *iq_id;
@@ -270,5 +272,5 @@
 	GSList *tflist;
 	struct bs_transfer *bt;
-	GSList *shlist=NULL;
+	GSList *shlist = NULL;
 	struct xt_node *shnode;
 
@@ -277,43 +279,39 @@
 	unsigned char hash[20];
 	int i;
-	
-	if( !(iq_id   = xt_find_attr( node, "id" ) ) ||
-	    !(ini_jid = xt_find_attr( node, "from" ) ) ||
-	    !(tgt_jid = xt_find_attr( node, "to" ) ) ||
-	    !(sid     = xt_find_attr( qnode, "sid" ) ) )
-	{
-		imcb_log( ic, "WARNING: Received incomplete SI bytestream request");
+
+	if (!(iq_id   = xt_find_attr(node, "id")) ||
+	    !(ini_jid = xt_find_attr(node, "from")) ||
+	    !(tgt_jid = xt_find_attr(node, "to")) ||
+	    !(sid     = xt_find_attr(qnode, "sid"))) {
+		imcb_log(ic, "WARNING: Received incomplete SI bytestream request");
 		return XT_HANDLED;
 	}
 
-	if( ( mode = xt_find_attr( qnode, "mode" ) ) &&
-	      ( strcmp( mode, "tcp" ) != 0 ) ) 
-	{
-		imcb_log( ic, "WARNING: Received SI Request for unsupported bytestream mode %s", xt_find_attr( qnode, "mode" ) );
+	if ((mode = xt_find_attr(qnode, "mode")) &&
+	    (strcmp(mode, "tcp") != 0)) {
+		imcb_log(ic, "WARNING: Received SI Request for unsupported bytestream mode %s",
+		         xt_find_attr(qnode, "mode"));
 		return XT_HANDLED;
 	}
 
 	shnode = qnode->children;
-	while( ( shnode = xt_find_node( shnode, "streamhost" ) ) )
-	{
+	while ((shnode = xt_find_node(shnode, "streamhost"))) {
 		char *jid, *host, *port_s;
 		int port;
-		if( ( jid = xt_find_attr( shnode, "jid" ) ) &&
-		    ( host = xt_find_attr( shnode, "host" ) ) &&
-		    ( port_s = xt_find_attr( shnode, "port" ) ) &&
-		    ( sscanf( port_s, "%d", &port ) == 1 ) )
-		{
-			jabber_streamhost_t *sh = g_new0( jabber_streamhost_t, 1 );
+		if ((jid = xt_find_attr(shnode, "jid")) &&
+		    (host = xt_find_attr(shnode, "host")) &&
+		    (port_s = xt_find_attr(shnode, "port")) &&
+		    (sscanf(port_s, "%d", &port) == 1)) {
+			jabber_streamhost_t *sh = g_new0(jabber_streamhost_t, 1);
 			sh->jid = g_strdup(jid);
 			sh->host = g_strdup(host);
-			sprintf( sh->port, "%u", port );
-			shlist = g_slist_append( shlist, sh );
+			sprintf(sh->port, "%u", port);
+			shlist = g_slist_append(shlist, sh);
 		}
 		shnode = shnode->next;
 	}
-	
-	if( !shlist )
-	{
-		imcb_log( ic, "WARNING: Received incomplete SI bytestream request, no parseable streamhost entries");
+
+	if (!shlist) {
+		imcb_log(ic, "WARNING: Received incomplete SI bytestream request, no parseable streamhost entries");
 		return XT_HANDLED;
 	}
@@ -321,48 +319,46 @@
 	/* Let's see if we can find out what this bytestream should be for... */
 
-	for( tflist = jd->filetransfers ; tflist; tflist = g_slist_next(tflist) )
-	{
+	for (tflist = jd->filetransfers; tflist; tflist = g_slist_next(tflist)) {
 		struct jabber_transfer *tft = tflist->data;
-		if( ( strcmp( tft->sid, sid ) == 0 ) &&
-		    ( strcmp( tft->ini_jid, ini_jid ) == 0 ) &&
-		    ( strcmp( tft->tgt_jid, tgt_jid ) == 0 ) )
-		{
-		    	tf = tft;
+		if ((strcmp(tft->sid, sid) == 0) &&
+		    (strcmp(tft->ini_jid, ini_jid) == 0) &&
+		    (strcmp(tft->tgt_jid, tgt_jid) == 0)) {
+			tf = tft;
 			break;
 		}
 	}
 
-	if (!tf) 
-	{
-		imcb_log( ic, "WARNING: Received bytestream request from %s that doesn't match an SI request", ini_jid );
+	if (!tf) {
+		imcb_log(ic, "WARNING: Received bytestream request from %s that doesn't match an SI request", ini_jid);
 		return XT_HANDLED;
 	}
 
 	/* iq_id and canceled can be reused since SI is done */
-	g_free( tf->iq_id );
-	tf->iq_id = g_strdup( iq_id );
+	g_free(tf->iq_id);
+	tf->iq_id = g_strdup(iq_id);
 
 	tf->ft->canceled = jabber_bs_canceled;
 
 	/* SHA1( SID + Initiator JID + Target JID ) is given to the streamhost which it will match against the initiator's value */
-	sha1_init( &sha );
-	sha1_append( &sha, (unsigned char*) sid, strlen( sid ) );
-	sha1_append( &sha, (unsigned char*) ini_jid, strlen( ini_jid ) );
-	sha1_append( &sha, (unsigned char*) tgt_jid, strlen( tgt_jid ) );
-	sha1_finish( &sha, hash );
-	
-	for( i = 0; i < 20; i ++ )
-		sprintf( hash_hex + i * 2, "%02x", hash[i] );
-		
-	bt = g_new0( struct bs_transfer, 1 );
+	sha1_init(&sha);
+	sha1_append(&sha, (unsigned char *) sid, strlen(sid));
+	sha1_append(&sha, (unsigned char *) ini_jid, strlen(ini_jid));
+	sha1_append(&sha, (unsigned char *) tgt_jid, strlen(tgt_jid));
+	sha1_finish(&sha, hash);
+
+	for (i = 0; i < 20; i++) {
+		sprintf(hash_hex + i * 2, "%02x", hash[i]);
+	}
+
+	bt = g_new0(struct bs_transfer, 1);
 	bt->tf = tf;
 	bt->streamhosts = shlist;
 	bt->sh = shlist->data;
 	bt->phase = BS_PHASE_CONNECT;
-	bt->pseudoadr = g_strdup( hash_hex );
+	bt->pseudoadr = g_strdup(hash_hex);
 	tf->streamhandle = bt;
 	tf->ft->free = jabber_bs_free_transfer;
 
-	jabber_bs_recv_handshake( bt, -1, 0 ); 
+	jabber_bs_recv_handshake(bt, -1, 0);
 
 	return XT_HANDLED;
@@ -376,5 +372,5 @@
  * All in all, it turned out quite nice :)
  */
-gboolean jabber_bs_recv_handshake( gpointer data, gint fd, b_input_condition cond )
+gboolean jabber_bs_recv_handshake(gpointer data, gint fd, b_input_condition cond)
 {
 
@@ -383,146 +379,152 @@
 	int gret;
 
-	if ( ( fd != -1 ) && !jabber_bs_poll( bt, fd, &revents ) )
+	if ((fd != -1) && !jabber_bs_poll(bt, fd, &revents)) {
 		return FALSE;
-	
-	switch( bt->phase ) 
+	}
+
+	switch (bt->phase) {
+	case BS_PHASE_CONNECT:
 	{
-	case BS_PHASE_CONNECT:
+		struct addrinfo hints, *rp;
+
+		memset(&hints, 0, sizeof(struct addrinfo));
+		hints.ai_socktype = SOCK_STREAM;
+
+		if ((gret = getaddrinfo(bt->sh->host, bt->sh->port, &hints, &rp)) != 0) {
+			return jabber_bs_abort(bt, "getaddrinfo() failed: %s", gai_strerror(gret));
+		}
+
+		ASSERTSOCKOP(bt->tf->fd = fd = socket(rp->ai_family, rp->ai_socktype, 0), "Opening socket");
+
+		sock_make_nonblocking(fd);
+
+		imcb_log(bt->tf->ic, "File %s: Connecting to streamhost %s:%s", bt->tf->ft->file_name, bt->sh->host,
+		         bt->sh->port);
+
+		if ((connect(fd, rp->ai_addr, rp->ai_addrlen) == -1) &&
+		    (errno != EINPROGRESS)) {
+			return jabber_bs_abort(bt, "connect() failed: %s", strerror(errno));
+		}
+
+		freeaddrinfo(rp);
+
+		bt->phase = BS_PHASE_CONNECTED;
+
+		bt->tf->watch_out = b_input_add(fd, B_EV_IO_WRITE, jabber_bs_recv_handshake, bt);
+
+		/* since it takes forever(3mins?) till connect() fails on itself we schedule a timeout */
+		bt->connect_timeout = b_timeout_add(JABBER_BS_CONTIMEOUT * 1000, jabber_bs_connect_timeout, bt);
+
+		bt->tf->watch_in = 0;
+		return FALSE;
+	}
+	case BS_PHASE_CONNECTED:
+	{
+		struct {
+			unsigned char ver;
+			unsigned char nmethods;
+			unsigned char method;
+		} socks5_hello = {
+			.ver = 5,
+			.nmethods = 1,
+			.method = 0x00         /* no auth */
+			          /* one could also implement username/password. If you know
+			           * a jabber client or proxy that actually does it, tell me.
+			           */
+		};
+
+		ASSERTSOCKOP(send(fd, &socks5_hello, sizeof(socks5_hello), 0), "Sending auth request");
+
+		bt->phase = BS_PHASE_REQUEST;
+
+		bt->tf->watch_in = b_input_add(fd, B_EV_IO_READ, jabber_bs_recv_handshake, bt);
+
+		bt->tf->watch_out = 0;
+		return FALSE;
+	}
+	case BS_PHASE_REQUEST:
+	{
+		struct socks5_message socks5_connect =
 		{
-			struct addrinfo hints, *rp;
-
-			memset( &hints, 0, sizeof( struct addrinfo ) );
-			hints.ai_socktype = SOCK_STREAM;
-
-			if ( ( gret = getaddrinfo( bt->sh->host, bt->sh->port, &hints, &rp ) ) != 0 )
-				return jabber_bs_abort( bt, "getaddrinfo() failed: %s", gai_strerror( gret ) );
-
-			ASSERTSOCKOP( bt->tf->fd = fd = socket( rp->ai_family, rp->ai_socktype, 0 ), "Opening socket" );
-
-			sock_make_nonblocking( fd );
-
-			imcb_log( bt->tf->ic, "File %s: Connecting to streamhost %s:%s", bt->tf->ft->file_name, bt->sh->host, bt->sh->port );
-
-			if( ( connect( fd, rp->ai_addr, rp->ai_addrlen ) == -1 ) &&
-			    ( errno != EINPROGRESS ) )
-				return jabber_bs_abort( bt , "connect() failed: %s", strerror( errno ) );
-
-			freeaddrinfo( rp );
-
-			bt->phase = BS_PHASE_CONNECTED;
-			
-			bt->tf->watch_out = b_input_add( fd, B_EV_IO_WRITE, jabber_bs_recv_handshake, bt );
-
-			/* since it takes forever(3mins?) till connect() fails on itself we schedule a timeout */
-			bt->connect_timeout = b_timeout_add( JABBER_BS_CONTIMEOUT * 1000, jabber_bs_connect_timeout, bt );
-
-			bt->tf->watch_in = 0;
+			.ver = 5,
+			.cmdrep.cmd = 0x01,
+			.rsv = 0,
+			.atyp = 0x03,
+			.addrlen = strlen(bt->pseudoadr),
+			.port = 0
+		};
+		int ret;
+		char buf[2];
+
+		/* If someone's trying to be funny and sends only one byte at a time we'll fail :) */
+		ASSERTSOCKOP(ret = recv(fd, buf, 2, 0), "Receiving auth reply");
+
+		if (!(ret == 2) ||
+		    !(buf[0] == 5) ||
+		    !(buf[1] == 0)) {
+			return jabber_bs_abort(bt, "Auth not accepted by streamhost (reply: len=%d, ver=%d, status=%d)",
+			                       ret, buf[0], buf[1]);
+		}
+
+		/* copy hash into connect message */
+		memcpy(socks5_connect.address, bt->pseudoadr, socks5_connect.addrlen);
+
+		ASSERTSOCKOP(send(fd, &socks5_connect, sizeof(struct socks5_message), 0), "Sending SOCKS5 Connect");
+
+		bt->phase = BS_PHASE_REPLY;
+
+		return TRUE;
+	}
+	case BS_PHASE_REPLY:
+	{
+		struct socks5_message socks5_reply;
+		int ret;
+
+		if (!(ret = jabber_bs_peek(bt, &socks5_reply, sizeof(struct socks5_message)))) {
 			return FALSE;
 		}
-	case BS_PHASE_CONNECTED:
-		{
-			struct {
-				unsigned char ver;
-				unsigned char nmethods;
-				unsigned char method;
-			} socks5_hello = {
-				.ver = 5,
-				.nmethods = 1,
-				.method = 0x00 /* no auth */
-				/* one could also implement username/password. If you know
-				 * a jabber client or proxy that actually does it, tell me.
-				 */
-			};
-			
-			ASSERTSOCKOP( send( fd, &socks5_hello, sizeof( socks5_hello ) , 0 ), "Sending auth request" );
-
-			bt->phase = BS_PHASE_REQUEST;
-
-			bt->tf->watch_in = b_input_add( fd, B_EV_IO_READ, jabber_bs_recv_handshake, bt );
-
-			bt->tf->watch_out = 0;
-			return FALSE;
-		}
-	case BS_PHASE_REQUEST:
-		{
-			struct socks5_message socks5_connect = 
-			{
-				.ver = 5,
-				.cmdrep.cmd = 0x01,
-				.rsv = 0,
-				.atyp = 0x03,
-				.addrlen = strlen( bt->pseudoadr ),
-				.port = 0
-			};
-			int ret;
-			char buf[2];
-
-			/* If someone's trying to be funny and sends only one byte at a time we'll fail :) */
-			ASSERTSOCKOP( ret = recv( fd, buf, 2, 0 ) , "Receiving auth reply" );
-
-			if( !( ret == 2 ) ||
-			    !( buf[0] == 5 ) ||
-			    !( buf[1] == 0 ) )
-				return jabber_bs_abort( bt, "Auth not accepted by streamhost (reply: len=%d, ver=%d, status=%d)",
-									ret, buf[0], buf[1] );
-
-			/* copy hash into connect message */
-			memcpy( socks5_connect.address, bt->pseudoadr, socks5_connect.addrlen );
-
-			ASSERTSOCKOP( send( fd, &socks5_connect, sizeof( struct socks5_message ), 0 ) , "Sending SOCKS5 Connect" );
-
-			bt->phase = BS_PHASE_REPLY;
-
+
+		if (ret < 5) {         /* header up to address length */
 			return TRUE;
-		}
-	case BS_PHASE_REPLY:
-		{
-			struct socks5_message socks5_reply;
-			int ret;
-
-			if ( !( ret = jabber_bs_peek( bt, &socks5_reply, sizeof( struct socks5_message ) ) ) )
-				return FALSE;
-
-			if ( ret < 5 ) /* header up to address length */
-				return TRUE;
-			else if( ret < sizeof( struct socks5_message ) )
-			{
-				/* Either a buggy proxy or just one that doesnt regard
-				 * the SHOULD in XEP-0065 saying the reply SHOULD
-				 * contain the address. We'll take it, so make sure the
-				 * next jabber_bs_peek starts with an empty buffer. */
-				bt->peek_buf_len = 0;
+		} else if (ret < sizeof(struct socks5_message)) {
+			/* Either a buggy proxy or just one that doesnt regard
+			 * the SHOULD in XEP-0065 saying the reply SHOULD
+			 * contain the address. We'll take it, so make sure the
+			 * next jabber_bs_peek starts with an empty buffer. */
+			bt->peek_buf_len = 0;
+		}
+
+		if (!(socks5_reply.ver == 5) ||
+		    !(socks5_reply.cmdrep.rep == 0)) {
+			char errstr[128] = "";
+			if ((socks5_reply.ver == 5) && (socks5_reply.cmdrep.rep <
+			                                (sizeof(socks5_reply_code) / sizeof(socks5_reply_code[0])))) {
+				sprintf(errstr, "with \"%s\" ", socks5_reply_code[ socks5_reply.cmdrep.rep ]);
 			}
-
-			if( !( socks5_reply.ver == 5 ) ||
-			    !( socks5_reply.cmdrep.rep == 0 ) ) {
-			    	char errstr[128] = "";
-				if( ( socks5_reply.ver == 5 ) && ( socks5_reply.cmdrep.rep < 
-				    ( sizeof( socks5_reply_code ) / sizeof( socks5_reply_code[0] ) ) ) ) {
-					sprintf( errstr, "with \"%s\" ", socks5_reply_code[ socks5_reply.cmdrep.rep ] );
-				}
-				return jabber_bs_abort( bt, "SOCKS5 CONNECT failed %s(reply: ver=%d, rep=%d, atyp=%d, addrlen=%d)", 
-					errstr,
-					socks5_reply.ver,
-					socks5_reply.cmdrep.rep,
-					socks5_reply.atyp,
-					socks5_reply.addrlen);
-			}
-			
-			/* usually a proxy sends back the 40 bytes address but I encountered at least one (of jabber.cz) 
-			 * that sends atyp=0 addrlen=0 and only 6 bytes (one less than one would expect).
-			 * Therefore I removed the wait for more bytes. Since we don't care about what else the proxy
-			 * is sending, it shouldnt matter */
-
-			if( bt->tf->ft->sending )
-				jabber_bs_send_activate( bt );
-			else
-				jabber_bs_recv_answer_request( bt );
-
-			return FALSE;
-		}
+			return jabber_bs_abort(bt,
+			                       "SOCKS5 CONNECT failed %s(reply: ver=%d, rep=%d, atyp=%d, addrlen=%d)",
+			                       errstr,
+			                       socks5_reply.ver,
+			                       socks5_reply.cmdrep.rep,
+			                       socks5_reply.atyp,
+			                       socks5_reply.addrlen);
+		}
+
+		/* usually a proxy sends back the 40 bytes address but I encountered at least one (of jabber.cz)
+		 * that sends atyp=0 addrlen=0 and only 6 bytes (one less than one would expect).
+		 * Therefore I removed the wait for more bytes. Since we don't care about what else the proxy
+		 * is sending, it shouldnt matter */
+
+		if (bt->tf->ft->sending) {
+			jabber_bs_send_activate(bt);
+		} else {
+			jabber_bs_recv_answer_request(bt);
+		}
+
+		return FALSE;
+	}
 	default:
 		/* BUG */
-		imcb_log( bt->tf->ic, "BUG in file transfer code: undefined handshake phase" );
+		imcb_log(bt->tf->ic, "BUG in file transfer code: undefined handshake phase");
 
 		bt->tf->watch_in = 0;
@@ -534,10 +536,10 @@
  * If the handshake failed we can try the next streamhost, if there is one.
  * An intelligent sender would probably specify himself as the first streamhost and
- * a proxy as the second (Kopete and PSI are examples here). That way, a (potentially) 
+ * a proxy as the second (Kopete and PSI are examples here). That way, a (potentially)
  * slow proxy is only used if neccessary. This of course also means, that the timeout
  * per streamhost should be kept short. If one or two firewalled adresses are specified,
  * they have to timeout first before a proxy is tried.
  */
-gboolean jabber_bs_recv_handshake_abort( struct bs_transfer *bt, char *error )
+gboolean jabber_bs_recv_handshake_abort(struct bs_transfer *bt, char *error)
 {
 	struct jabber_transfer *tf = bt->tf;
@@ -545,17 +547,16 @@
 	GSList *shlist;
 
-	imcb_log( tf->ic, "Transferring file %s: connection to streamhost %s:%s failed (%s)", 
-		  tf->ft->file_name, 
-		  bt->sh->host,
-		  bt->sh->port,
-		  error );
+	imcb_log(tf->ic, "Transferring file %s: connection to streamhost %s:%s failed (%s)",
+	         tf->ft->file_name,
+	         bt->sh->host,
+	         bt->sh->port,
+	         error);
 
 	/* Alright, this streamhost failed, let's try the next... */
 	bt->phase = BS_PHASE_CONNECT;
-	shlist = g_slist_find( bt->streamhosts, bt->sh );
-	if( shlist && shlist->next )
-	{
+	shlist = g_slist_find(bt->streamhosts, bt->sh);
+	if (shlist && shlist->next) {
 		bt->sh = shlist->next->data;
-		return jabber_bs_recv_handshake( bt, -1, 0 );
+		return jabber_bs_recv_handshake(bt, -1, 0);
 	}
 
@@ -563,15 +564,16 @@
 	/* out of stream hosts */
 
-	iqnode = jabber_make_packet( "iq", "result", tf->ini_jid, NULL );
-	reply = jabber_make_error_packet( iqnode, "item-not-found", "cancel" , "404" );
-	xt_free_node( iqnode );
-
-	xt_add_attr( reply, "id", tf->iq_id );
-		
-	if( !jabber_write_packet( tf->ic, reply ) )
-		imcb_log( tf->ic, "WARNING: Error transmitting bytestream response" );
-	xt_free_node( reply );
-
-	imcb_file_canceled( tf->ic, tf->ft, "couldn't connect to any streamhosts" );
+	iqnode = jabber_make_packet("iq", "result", tf->ini_jid, NULL);
+	reply = jabber_make_error_packet(iqnode, "item-not-found", "cancel", "404");
+	xt_free_node(iqnode);
+
+	xt_add_attr(reply, "id", tf->iq_id);
+
+	if (!jabber_write_packet(tf->ic, reply)) {
+		imcb_log(tf->ic, "WARNING: Error transmitting bytestream response");
+	}
+	xt_free_node(reply);
+
+	imcb_file_canceled(tf->ic, tf->ft, "couldn't connect to any streamhosts");
 
 	/* MUST always return FALSE! */
@@ -579,43 +581,44 @@
 }
 
-/* 
+/*
  * After the SOCKS5 handshake succeeds we need to inform the initiator which streamhost we chose.
  * If he is the streamhost himself, he might already know that. However, if it's a proxy,
  * the initiator will have to make a connection himself.
  */
-void jabber_bs_recv_answer_request( struct bs_transfer *bt )
+void jabber_bs_recv_answer_request(struct bs_transfer *bt)
 {
 	struct jabber_transfer *tf = bt->tf;
 	struct xt_node *reply;
 
-	imcb_log( tf->ic, "File %s: established SOCKS5 connection to %s:%s", 
-		  tf->ft->file_name, 
-		  bt->sh->host,
-		  bt->sh->port );
+	imcb_log(tf->ic, "File %s: established SOCKS5 connection to %s:%s",
+	         tf->ft->file_name,
+	         bt->sh->host,
+	         bt->sh->port);
 
 	tf->ft->data = tf;
-	tf->watch_in = b_input_add( tf->fd, B_EV_IO_READ, jabber_bs_recv_read, bt );
+	tf->watch_in = b_input_add(tf->fd, B_EV_IO_READ, jabber_bs_recv_read, bt);
 	tf->ft->write_request = jabber_bs_recv_write_request;
 
-	reply = xt_new_node( "streamhost-used", NULL, NULL );
-	xt_add_attr( reply, "jid", bt->sh->jid );
-
-	reply = xt_new_node( "query", NULL, reply );
-	xt_add_attr( reply, "xmlns", XMLNS_BYTESTREAMS );
-
-	reply = jabber_make_packet( "iq", "result", tf->ini_jid, reply );
-
-	xt_add_attr( reply, "id", tf->iq_id );
-		
-	if( !jabber_write_packet( tf->ic, reply ) )
-		imcb_file_canceled( tf->ic, tf->ft, "Error transmitting bytestream response" );
-	xt_free_node( reply );
-}
-
-/* 
+	reply = xt_new_node("streamhost-used", NULL, NULL);
+	xt_add_attr(reply, "jid", bt->sh->jid);
+
+	reply = xt_new_node("query", NULL, reply);
+	xt_add_attr(reply, "xmlns", XMLNS_BYTESTREAMS);
+
+	reply = jabber_make_packet("iq", "result", tf->ini_jid, reply);
+
+	xt_add_attr(reply, "id", tf->iq_id);
+
+	if (!jabber_write_packet(tf->ic, reply)) {
+		imcb_file_canceled(tf->ic, tf->ft, "Error transmitting bytestream response");
+	}
+	xt_free_node(reply);
+}
+
+/*
  * This function is called from write_request directly. If no data is available, it will install itself
  * as a watcher for input on fd and once that happens, deliver the data and unschedule itself again.
  */
-gboolean jabber_bs_recv_read( gpointer data, gint fd, b_input_condition cond )
+gboolean jabber_bs_recv_read(gpointer data, gint fd, b_input_condition cond)
 {
 	int ret;
@@ -623,19 +626,16 @@
 	struct jabber_transfer *tf = bt->tf;
 
-	if( fd != -1 ) /* called via event thread */
-	{
+	if (fd != -1) { /* called via event thread */
 		tf->watch_in = 0;
-		ASSERTSOCKOP( ret = recv( fd, tf->ft->buffer, sizeof( tf->ft->buffer ), 0 ) , "Receiving" );
-	}
-	else
-	{
+		ASSERTSOCKOP(ret = recv(fd, tf->ft->buffer, sizeof(tf->ft->buffer), 0), "Receiving");
+	} else {
 		/* called directly. There might not be any data available. */
-		if( ( ( ret = recv( tf->fd, tf->ft->buffer, sizeof( tf->ft->buffer ), 0 ) ) == -1 ) &&
-		    ( errno != EAGAIN ) )
-		    return jabber_bs_abort( bt, "Receiving: %s", strerror( errno ) );
-
-		if( ( ret == -1 ) && ( errno == EAGAIN ) )
-		{
-			tf->watch_in = b_input_add( tf->fd, B_EV_IO_READ, jabber_bs_recv_read, bt );
+		if (((ret = recv(tf->fd, tf->ft->buffer, sizeof(tf->ft->buffer), 0)) == -1) &&
+		    (errno != EAGAIN)) {
+			return jabber_bs_abort(bt, "Receiving: %s", strerror(errno));
+		}
+
+		if ((ret == -1) && (errno == EAGAIN)) {
+			tf->watch_in = b_input_add(tf->fd, B_EV_IO_READ, jabber_bs_recv_read, bt);
 			return FALSE;
 		}
